Index: trunk/src/VBox/Main/src-server/HostPower.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/HostPower.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/HostPower.cpp	(revision 57358)
@@ -18,7 +18,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 
 #include "HostPower.h"
Index: trunk/src/VBox/Main/src-server/HostUSBDeviceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/HostUSBDeviceImpl.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/HostUSBDeviceImpl.cpp	(revision 57358)
@@ -350,5 +350,5 @@
             name = "<unknown>";
             LogRel(("USB: Unknown USB device detected ( idVendor: 0x%04x, idProduct: 0x%04x ). \
-                Please, report the idVendor and idProduct to vbox.org.\n", vendorName, productName)); 
+                Please, report the idVendor and idProduct to vbox.org.\n", vendorName, productName));
         }
     }
Index: trunk/src/VBox/Main/src-server/USBIdDatabaseGenerator.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBIdDatabaseGenerator.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/USBIdDatabaseGenerator.cpp	(revision 57358)
@@ -54,5 +54,5 @@
 const size_t AliasDictionary::vendors_size = sizeof(AliasDictionary::vendorArray) / sizeof(Vendor);";
 
-const char* start_block = "#		interface  interface_name		<-- two tabs";
+const char* start_block = "#            interface  interface_name               <-- two tabs";
 const char* end_block = "# List of known device classes, subclasses and protocols";
 
Index: trunk/src/VBox/Main/src-server/USBIdDatabaseStub.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBIdDatabaseStub.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/USBIdDatabaseStub.cpp	(revision 57358)
@@ -20,5 +20,5 @@
 Product AliasDictionary::productArray[] = {0};
 
-const size_t AliasDictionary::products_size = sizeof(AliasDictionary::productArray) / sizeof(Product); 
+const size_t AliasDictionary::products_size = sizeof(AliasDictionary::productArray) / sizeof(Product);
 
 Vendor AliasDictionary::vendorArray[] = {0};
Index: trunk/src/VBox/Main/src-server/darwin/NetIf-darwin.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/darwin/NetIf-darwin.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/darwin/NetIf-darwin.cpp	(revision 57358)
@@ -18,7 +18,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 /*
  * Deal with conflicts first.
Index: trunk/src/VBox/Main/src-server/darwin/USBProxyServiceDarwin.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/darwin/USBProxyServiceDarwin.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/darwin/USBProxyServiceDarwin.cpp	(revision 57358)
@@ -17,7 +17,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "USBProxyService.h"
 #include "Logging.h"
Index: trunk/src/VBox/Main/src-server/darwin/iokit.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/darwin/iokit.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/darwin/iokit.cpp	(revision 57358)
@@ -21,7 +21,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define LOG_GROUP LOG_GROUP_MAIN
 #ifdef STANDALONE_TESTCASE
@@ -63,7 +63,7 @@
 
 
-/*******************************************************************************
-*   Defined Constants And Macros                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Defined Constants And Macros                                                                                                 *
+*********************************************************************************************************************************/
 /** An attempt at catching reference leaks. */
 #define MY_CHECK_CREFS(cRefs)   do { AssertMsg(cRefs < 25, ("%ld\n", cRefs)); NOREF(cRefs); } while (0)
@@ -77,7 +77,7 @@
 
 
-/*******************************************************************************
-*   Global Variables                                                           *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Global Variables                                                                                                             *
+*********************************************************************************************************************************/
 /** The IO Master Port. */
 static mach_port_t g_MasterPort = NULL;
Index: trunk/src/VBox/Main/src-server/freebsd/HostHardwareFreeBSD.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/freebsd/HostHardwareFreeBSD.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/freebsd/HostHardwareFreeBSD.cpp	(revision 57358)
@@ -18,7 +18,8 @@
 #define LOG_GROUP LOG_GROUP_MAIN
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 
 #include <HostHardwareLinux.h>
@@ -48,7 +49,8 @@
 #include <vector>
 
-/******************************************************************************
-*   Typedefs and Defines                                                      *
-******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Typedefs and Defines                                                                                                         *
+*********************************************************************************************************************************/
 
 static int getDriveInfoFromEnv(const char *pcszVar, DriveInfoList *pList,
Index: trunk/src/VBox/Main/src-server/freebsd/NetIf-freebsd.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/freebsd/NetIf-freebsd.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/freebsd/NetIf-freebsd.cpp	(revision 57358)
@@ -21,7 +21,8 @@
  */
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define LOG_GROUP LOG_GROUP_MAIN
 #include <sys/types.h>
Index: trunk/src/VBox/Main/src-server/freebsd/USBProxyServiceFreeBSD.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/freebsd/USBProxyServiceFreeBSD.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/freebsd/USBProxyServiceFreeBSD.cpp	(revision 57358)
@@ -17,7 +17,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "USBProxyService.h"
 #include "Logging.h"
@@ -47,12 +47,13 @@
 #include <dev/usb/usb_ioctl.h>
 
-/*******************************************************************************
-*   Structures and Typedefs                                                    *
-*******************************************************************************/
-
-
-/*******************************************************************************
-*   Global Variables                                                           *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Structures and Typedefs                                                                                                      *
+*********************************************************************************************************************************/
+
+
+/*********************************************************************************************************************************
+*   Global Variables                                                                                                             *
+*********************************************************************************************************************************/
 
 /**
Index: trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp	(revision 57358)
@@ -20,7 +20,8 @@
 #define LOG_GROUP LOG_GROUP_MAIN
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 
 #include <HostHardwareLinux.h>
@@ -65,7 +66,8 @@
 #include <sys/types.h>
 
-/******************************************************************************
-*   Global Variables                                                          *
-******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Global Variables                                                                                                             *
+*********************************************************************************************************************************/
 
 #ifdef TESTCASE
@@ -80,7 +82,8 @@
 #endif
 
-/******************************************************************************
-*   Typedefs and Defines                                                      *
-******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Typedefs and Defines                                                                                                         *
+*********************************************************************************************************************************/
 
 static int getDriveInfoFromEnv(const char *pcszVar, DriveInfoList *pList,
Index: trunk/src/VBox/Main/src-server/linux/NetIf-linux.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/NetIf-linux.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/linux/NetIf-linux.cpp	(revision 57358)
@@ -18,7 +18,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define LOG_GROUP LOG_GROUP_MAIN
 
Index: trunk/src/VBox/Main/src-server/linux/USBGetDevices.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/USBGetDevices.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/linux/USBGetDevices.cpp	(revision 57358)
@@ -17,7 +17,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 
 #include "USBGetDevices.h"
@@ -58,7 +58,8 @@
 #include <unistd.h>
 
-/*******************************************************************************
-*   Structures and Typedefs                                                    *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Structures and Typedefs                                                                                                      *
+*********************************************************************************************************************************/
 /** Suffix translation. */
 typedef struct USBSUFF
@@ -83,7 +84,8 @@
 } USBDeviceInfo;
 
-/*******************************************************************************
-*   Global Variables                                                           *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Global Variables                                                                                                             *
+*********************************************************************************************************************************/
 /**
  * Suffixes for the endpoint polling interval.
Index: trunk/src/VBox/Main/src-server/linux/USBProxyServiceLinux.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/USBProxyServiceLinux.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/linux/USBProxyServiceLinux.cpp	(revision 57358)
@@ -17,7 +17,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "USBProxyService.h"
 #include "USBGetDevices.h"
Index: trunk/src/VBox/Main/src-server/os2/NetIf-os2.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/os2/NetIf-os2.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/os2/NetIf-os2.cpp	(revision 57358)
@@ -18,7 +18,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define LOG_GROUP LOG_GROUP_MAIN
 
Index: trunk/src/VBox/Main/src-server/os2/USBProxyServiceOs2.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/os2/USBProxyServiceOs2.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/os2/USBProxyServiceOs2.cpp	(revision 57358)
@@ -17,7 +17,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define INCL_BASE
 #define INCL_ERRORS
Index: trunk/src/VBox/Main/src-server/solaris/NetIf-solaris.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/solaris/NetIf-solaris.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/solaris/NetIf-solaris.cpp	(revision 57358)
@@ -18,7 +18,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define LOG_GROUP LOG_GROUP_MAIN
 
Index: trunk/src/VBox/Main/src-server/solaris/USBProxyServiceSolaris.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/solaris/USBProxyServiceSolaris.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/solaris/USBProxyServiceSolaris.cpp	(revision 57358)
@@ -17,7 +17,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "USBProxyService.h"
 #include "Logging.h"
@@ -32,7 +32,8 @@
 #include <syslog.h>
 
-/*******************************************************************************
-*   Internal Functions                                                         *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Internal Functions                                                                                                           *
+*********************************************************************************************************************************/
 static int solarisWalkDeviceNode(di_node_t Node, void *pvArg);
 static void solarisFreeUSBDevice(PUSBDEVICE pDevice);
@@ -40,7 +41,7 @@
 
 
-/*******************************************************************************
-*   Structures and Typedefs                                                    *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Structures and Typedefs                                                                                                      *
+*********************************************************************************************************************************/
 typedef struct USBDEVICELIST
 {
Index: trunk/src/VBox/Main/src-server/win/HostPowerWin.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/win/HostPowerWin.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/win/HostPowerWin.cpp	(revision 57358)
@@ -17,7 +17,8 @@
  */
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include <windows.h>
 /* Some SDK versions lack the extern "C" and thus cause linking failures.
Index: trunk/src/VBox/Main/src-server/win/NetIf-win.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/win/NetIf-win.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/win/NetIf-win.cpp	(revision 57358)
@@ -18,7 +18,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #define LOG_GROUP LOG_GROUP_MAIN
 
Index: trunk/src/VBox/Main/src-server/win/USBProxyServiceWindows.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/win/USBProxyServiceWindows.cpp	(revision 57338)
+++ trunk/src/VBox/Main/src-server/win/USBProxyServiceWindows.cpp	(revision 57358)
@@ -17,7 +17,7 @@
 
 
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
 #include "USBProxyService.h"
 #include "Logging.h"