Index: /trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-ogl.cpp
===================================================================
--- /trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-ogl.cpp	(revision 57502)
+++ /trunk/src/VBox/Devices/Graphics/DevVGA-SVGA3d-ogl.cpp	(revision 57503)
@@ -140,5 +140,5 @@
 *********************************************************************************************************************************/
 /* Define the default light parameters as specified by MSDN. */
-/* @todo move out; fetched from Wine */
+/** @todo move out; fetched from Wine */
 const SVGA3dLightData vmsvga3d_default_light =
 {
@@ -845,5 +845,5 @@
      *
      */
-    /** @todo: distinguish between vertex and pixel shaders??? */
+    /** @todo distinguish between vertex and pixel shaders??? */
     if (   vmsvga3dCheckGLExtension(pState, 0.0f, " GL_NV_gpu_program4 ")
         || strstr(pState->pszOtherExtensions, " GL_NV_gpu_program4 "))
@@ -1097,5 +1097,5 @@
     uint32_t result = 0;
 
-    /* @todo missing:
+    /** @todo missing:
      *
      * SVGA3DFORMAT_OP_PIXELSIZE
@@ -1123,5 +1123,5 @@
     }
 
-    /* @todo check hardware caps! */
+    /** @todo check hardware caps! */
     switch (idx3dCaps)
     {
@@ -1201,5 +1201,5 @@
     uint32_t result = 0;
 
-    /* @todo test this somehow */
+    /** @todo test this somehow */
     result = SVGA3DFORMAT_OP_ZSTENCIL | SVGA3DFORMAT_OP_ZSTENCIL_WITH_ARBITRARY_COLOR_DEPTH;
 
@@ -1296,5 +1296,5 @@
 
     case SVGA3D_DEVCAP_MAX_SHADER_TEXTURES:
-        /* @todo ?? */
+        /** @todo ?? */
         rc = VERR_INVALID_PARAMETER;
         break;
@@ -1370,5 +1370,5 @@
         break;
 
-    case SVGA3D_DEVCAP_MAX_RENDER_TARGETS:  /* @todo same thing? */
+    case SVGA3D_DEVCAP_MAX_RENDER_TARGETS:  /** @todo same thing? */
     case SVGA3D_DEVCAP_MAX_SIMULTANEOUS_RENDER_TARGETS:
         *pu32Val = pState->caps.maxColorAttachments;
@@ -1802,5 +1802,5 @@
         return D3DMULTISAMPLE_NONE;
 
-    /* @todo exact same mapping as d3d? */
+    /** @todo exact same mapping as d3d? */
     return (D3DMULTISAMPLE_TYPE)multisampleCount;
 }
@@ -1821,5 +1821,5 @@
     {
     case SVGA3D_SURFACE_CUBEMAP:
-        AssertFailed(); /** @todo */
+        AssertFailed(); /** @todo destroy SVGA3D_SURFACE_CUBEMAP */
         break;
 
@@ -2026,5 +2026,5 @@
     glGenTextures(1, &pSurface->oglId.texture);
     VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
-    /* @todo Set the mip map generation filter settings. */
+    /** @todo Set the mip map generation filter settings. */
 
     glGetIntegerv(GL_TEXTURE_BINDING_2D, &activeTexture);
@@ -2421,5 +2421,5 @@
 
     case SVGA3D_SURFACE_HINT_DEPTHSTENCIL:
-        AssertFailed(); /* @todo */
+        AssertFailed(); /** @todo DMA SVGA3D_SURFACE_HINT_DEPTHSTENCIL */
         break;
 
@@ -2502,8 +2502,8 @@
     }
 
-    /* @todo Only screen 0 for now. */
+    /** @todo Only screen 0 for now. */
     AssertReturn(dest == 0, VERR_INTERNAL_ERROR);
     AssertReturn(src.mipmap == 0 && src.face == 0, VERR_INVALID_PARAMETER);
-    /* @todo scaling */
+    /** @todo scaling */
     AssertReturn(destRect.right - destRect.left == srcRect.right - srcRect.left && destRect.bottom - destRect.top == srcRect.bottom - srcRect.top, VERR_INVALID_PARAMETER);
 
@@ -2547,5 +2547,5 @@
         dst.pitch      = pThis->svga.cbScanline;
 
-        /* @todo merge into one SurfaceDMA call */
+        /** @todo merge into one SurfaceDMA call */
         for (uint32_t i = 0; i < cRects; i++)
         {
@@ -2604,5 +2604,5 @@
     else
     {
-        /* @todo new filter */
+        /** @todo new filter */
         AssertFailed();
     }
@@ -2640,5 +2640,5 @@
     pSurface = pState->papSurfaces[sid];
 
-    /* @todo stricter checks for associated context */
+    /** @todo stricter checks for associated context */
     Log(("vmsvga3dCommandPresent: sid=%x cRects=%d\n", sid, cRects));
     for (uint32_t i=0; i < cRects; i++)
@@ -3155,5 +3155,5 @@
 
     pixelFormat = ChoosePixelFormat(pContext->hdc, &pfd);
-    /* @todo is this really necessary?? */
+    /** @todo is this really necessary?? */
     pixelFormat = ChoosePixelFormat(pContext->hdc, &pfd);
     AssertMsgReturn(pixelFormat != 0, ("ChoosePixelFormat failed with %d\n", GetLastError()), VERR_INTERNAL_ERROR);
@@ -3253,5 +3253,5 @@
     }
 #if 0
-    /* @todo move to shader lib!!! */
+    /** @todo move to shader lib!!! */
     /* Clear the screen */
     VMSVGA3D_SET_CURRENT_CONTEXT(pState, pContext);
@@ -3266,5 +3266,5 @@
     if (pState->ext.glProvokingVertex)
         pState->ext.glProvokingVertex(GL_FIRST_VERTEX_CONVENTION);
-    /* @todo move to shader lib!!! */
+    /** @todo move to shader lib!!! */
 #endif
     return VINF_SUCCESS;
@@ -3615,7 +3615,7 @@
         return GL_SRC_ALPHA_SATURATE;
     case SVGA3D_BLENDOP_BLENDFACTOR:
-        return GL_CONSTANT_ALPHA;       /* @todo correct?? */
+        return GL_CONSTANT_ALPHA;       /** @todo correct?? */
     case SVGA3D_BLENDOP_INVBLENDFACTOR:
-        return GL_ONE_MINUS_CONSTANT_ALPHA;       /* @todo correct?? */
+        return GL_ONE_MINUS_CONSTANT_ALPHA;       /** @todo correct?? */
     default:
         AssertFailed();
@@ -3769,5 +3769,5 @@
 
         case SVGA3D_RS_POINTSIZE:              /* float */
-            /* @todo we need to apply scaling for point sizes below the min or above the max; see Wine) */
+            /** @todo we need to apply scaling for point sizes below the min or above the max; see Wine) */
             if (pRenderState[i].floatValue < pState->caps.flPointSize[0])
                 pRenderState[i].floatValue = pState->caps.flPointSize[0];
@@ -3877,5 +3877,5 @@
             }
 
-            /* @todo how to switch between vertex and pixel fog modes??? */
+            /** @todo how to switch between vertex and pixel fog modes??? */
             Assert(mode.s.type == SVGA3D_FOGTYPE_PIXEL);
 #if 0
@@ -3964,5 +3964,5 @@
         case SVGA3D_RS_LINEPATTERN:            /* SVGA3dLinePattern */
             /* No longer supported by d3d; mesagl comments suggest not all backends support it */
-            /* @todo */
+            /** @todo */
             Log(("WARNING: SVGA3D_RS_LINEPATTERN %x not supported!!\n", pRenderState[i].uintValue));
             /*
@@ -4238,6 +4238,6 @@
         case SVGA3D_RS_CCWSTENCILFUNC:         /* SVGA3dCmpFunc */
         {
-            /* @todo SVGA3D_RS_STENCILFAIL/ZFAIL/PASS for front & back faces
-             *       SVGA3D_RS_CCWSTENCILFAIL/ZFAIL/PASS for back faces ??
+            /** @todo SVGA3D_RS_STENCILFAIL/ZFAIL/PASS for front & back faces
+             *        SVGA3D_RS_CCWSTENCILFAIL/ZFAIL/PASS for back faces ??
              */
             GLint ref;
@@ -4258,6 +4258,6 @@
         case SVGA3D_RS_CCWSTENCILPASS:         /* SVGA3dStencilOp */
         {
-            /* @todo SVGA3D_RS_STENCILFAIL/ZFAIL/PASS for front & back faces
-             *       SVGA3D_RS_CCWSTENCILFAIL/ZFAIL/PASS for back faces ??
+            /** @todo SVGA3D_RS_STENCILFAIL/ZFAIL/PASS for front & back faces
+             *        SVGA3D_RS_CCWSTENCILFAIL/ZFAIL/PASS for back faces ??
              */
             GLint sfail, dpfail, dppass;
@@ -4293,5 +4293,5 @@
 
         case SVGA3D_RS_ZBIAS:                  /* float */
-            /* @todo unknown meaning; depth bias is not identical
+            /** @todo unknown meaning; depth bias is not identical
             renderState = D3DRS_DEPTHBIAS;
             val = pRenderState[i].uintValue;
@@ -4304,5 +4304,5 @@
             GLfloat factor;
 
-            /* @todo not sure if the d3d & ogl definitions are identical. */
+            /** @todo not sure if the d3d & ogl definitions are identical. */
 
             /* Do not change the factor part. */
@@ -4319,5 +4319,5 @@
             GLfloat units;
 
-            /* @todo not sure if the d3d & ogl definitions are identical. */
+            /** @todo not sure if the d3d & ogl definitions are identical. */
 
             /* Do not change the factor part. */
@@ -4416,5 +4416,5 @@
         case SVGA3D_RS_COORDINATETYPE:         /* SVGA3dCoordinateType */
             Assert(pRenderState[i].uintValue == SVGA3D_COORDINATE_LEFTHANDED);
-            /* @todo setup a view matrix to scale the world space by -1 in the z-direction for right handed coordinates. */
+            /** @todo setup a view matrix to scale the world space by -1 in the z-direction for right handed coordinates. */
             /*
             renderState = D3DRS_COORDINATETYPE;
@@ -4661,5 +4661,5 @@
             Log(("vmsvga3dSetRenderTarget: WARNING: glCheckFramebufferStatus returned %x\n", status));
 #endif
-        /* @todo use glDrawBuffers too? */
+        /** @todo use glDrawBuffers too? */
         break;
     }
@@ -4707,5 +4707,5 @@
         return D3DTOP_MODULATE4X;
     case SVGA3D_TC_DSDT:
-        AssertFailed(); /* @todo ??? */
+        AssertFailed(); /** @todo ??? */
         return D3DTOP_DISABLE;
     case SVGA3D_TC_DOTPRODUCT3:
@@ -4772,11 +4772,11 @@
         return D3DTTFF_DISABLE;
     case SVGA3D_TEX_TRANSFORM_S:
-        return D3DTTFF_COUNT1;      /* @todo correct? */
+        return D3DTTFF_COUNT1;      /** @todo correct? */
     case SVGA3D_TEX_TRANSFORM_T:
-        return D3DTTFF_COUNT2;      /* @todo correct? */
+        return D3DTTFF_COUNT2;      /** @todo correct? */
     case SVGA3D_TEX_TRANSFORM_R:
-        return D3DTTFF_COUNT3;      /* @todo correct? */
+        return D3DTTFF_COUNT3;      /** @todo correct? */
     case SVGA3D_TEX_TRANSFORM_Q:
-        return D3DTTFF_COUNT4;      /* @todo correct? */
+        return D3DTTFF_COUNT4;      /** @todo correct? */
     case SVGA3D_TEX_PROJECTED:
         return D3DTTFF_PROJECTED;
@@ -4802,5 +4802,5 @@
     case SVGA3D_TEX_ADDRESS_MIRRORONCE:
         AssertFailed();
-        return GL_CLAMP_TO_EDGE_SGIS; /* @todo correct? */
+        return GL_CLAMP_TO_EDGE_SGIS; /** @todo correct? */
 
     case SVGA3D_TEX_ADDRESS_EDGE:
@@ -4822,5 +4822,5 @@
         return GL_NEAREST;
     case SVGA3D_TEX_FILTER_ANISOTROPIC:
-        /* @todo */
+        /** @todo */
     case SVGA3D_TEX_FILTER_FLATCUBIC:       // Deprecated, not implemented
     case SVGA3D_TEX_FILTER_GAUSSIANCUBIC:   // Deprecated, not implemented
@@ -4910,5 +4910,5 @@
         case SVGA3D_TS_ALPHAARG1:                   /* SVGA3dTextureArgData */
         case SVGA3D_TS_ALPHAARG2:                   /* SVGA3dTextureArgData */
-            /* @todo; not used by MesaGL */
+            /** @todo not used by MesaGL */
             Log(("vmsvga3dSetTextureState: colorop/alphaop not yet supported!!\n"));
             break;
@@ -5044,5 +5044,5 @@
             vmsvgaColor2GLFloatArray(pTextureState[i].value, &color[0], &color[1], &color[2], &color[3]);
 
-            glTexParameterfv(GL_TEXTURE_2D /* @todo flexible type */, GL_TEXTURE_BORDER_COLOR, color);   /* Identical; default 0.0 identical too */
+            glTexParameterfv(GL_TEXTURE_2D /** @todo flexible type */, GL_TEXTURE_BORDER_COLOR, color);   /* Identical; default 0.0 identical too */
             VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
             break;
@@ -5050,5 +5050,5 @@
 
         case SVGA3D_TS_TEXTURE_LOD_BIAS:            /* float */
-            glTexParameterf(GL_TEXTURE_2D /* @todo flexible type */, GL_TEXTURE_LOD_BIAS, pTextureState[i].value);   /* Identical; default 0.0 identical too */
+            glTexParameterf(GL_TEXTURE_2D /** @todo flexible type */, GL_TEXTURE_LOD_BIAS, pTextureState[i].value);   /* Identical; default 0.0 identical too */
             VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
             break;
@@ -5086,5 +5086,5 @@
         if (textureType != ~0U)
         {
-            glTexParameteri(GL_TEXTURE_2D /* @todo flexible type */, textureType, val);
+            glTexParameteri(GL_TEXTURE_2D /** @todo flexible type */, textureType, val);
             VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
         }
@@ -5146,5 +5146,5 @@
 }
 
-/* @todo Move into separate library as we are using logic from Wine here. */
+/** @todo Move into separate library as we are using logic from Wine here. */
 int vmsvga3dSetLightData(PVGASTATE pThis, uint32_t cid, uint32_t index, SVGA3dLightData *pData)
 {
@@ -5223,5 +5223,5 @@
         VMSVGA3D_CHECK_LAST_ERROR_WARN(pState, pContext);
 
-        /* @todo range */
+        /** @todo range */
         break;
     }
@@ -5291,5 +5291,5 @@
         VMSVGA3D_CHECK_LAST_ERROR_WARN(pState, pContext);
 
-        /* @todo range */
+        /** @todo range */
         break;
     }
@@ -5385,5 +5385,5 @@
     pContext->state.u32UpdateFlags |= VMSVGA3D_UPDATE_VIEWPORT;
 
-    /* @todo y-inversion for partial viewport coordinates? */
+    /** @todo y-inversion for partial viewport coordinates? */
     glViewport(pRect->x, pRect->y, pRect->w, pRect->h);
     VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
@@ -5514,5 +5514,5 @@
     if (clearFlag & SVGA3D_CLEAR_STENCIL)
     {
-        /* @todo possibly the same problem as with glDepthMask */
+        /** @todo possibly the same problem as with glDepthMask */
         glClearStencil(stencil);
         mask |= GL_STENCIL_BUFFER_BIT;
@@ -5626,5 +5626,5 @@
     case SVGA3D_DECLTYPE_UDEC3:
         size = 3;
-        type = GL_UNSIGNED_INT_2_10_10_10_REV;    /* @todo correct? */
+        type = GL_UNSIGNED_INT_2_10_10_10_REV;    /** @todo correct? */
         break;
 
@@ -5632,5 +5632,5 @@
         normalized = true;
         size = 3;
-        type = GL_INT_2_10_10_10_REV;    /* @todo correct? */
+        type = GL_INT_2_10_10_10_REV;    /** @todo correct? */
         break;
 
@@ -5715,5 +5715,5 @@
 
         Assert(pVertexSurface->fDirty);
-        /* @todo rethink usage dynamic/static */
+        /** @todo rethink usage dynamic/static */
         pState->ext.glBufferData(GL_ARRAY_BUFFER, pVertexSurface->pMipmapLevels[0].cbSurface, pVertexSurface->pMipmapLevels[0].pSurfaceData, GL_DYNAMIC_DRAW);
         VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
@@ -5756,5 +5756,5 @@
                                               (const GLvoid *)(uintptr_t)pVertexDecl[iVertex].array.offset);
             VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
-            /* case SVGA3D_DECLUSAGE_COLOR:    @todo color component order not identical!! test GL_BGRA!!  */
+            /** @todo case SVGA3D_DECLUSAGE_COLOR: color component order not identical!! test GL_BGRA!!  */
         }
         else
@@ -5892,5 +5892,5 @@
             case SVGA3D_DECLUSAGE_POSITIONT:
                 break;
-            case SVGA3D_DECLUSAGE_COLOR:    /* @todo color component order not identical!! */
+            case SVGA3D_DECLUSAGE_COLOR:    /** @todo color component order not identical!! */
                 glDisableClientState(GL_COLOR_ARRAY);
                 VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
@@ -5927,5 +5927,5 @@
     AssertReturn(numRanges && numRanges <= SVGA3D_MAX_DRAW_PRIMITIVE_RANGES, VERR_INVALID_PARAMETER);
     AssertReturn(!cVertexDivisor || cVertexDivisor == numVertexDecls, VERR_INVALID_PARAMETER);
-    /* @todo */
+    /** @todo Non-zero cVertexDivisor */
     Assert(!cVertexDivisor);
 
@@ -6021,5 +6021,5 @@
                 Assert(pIndexSurface->fDirty);
 
-                /* @todo rethink usage dynamic/static */
+                /** @todo rethink usage dynamic/static */
                 pState->ext.glBufferData(GL_ELEMENT_ARRAY_BUFFER, pIndexSurface->pMipmapLevels[0].cbSurface, pIndexSurface->pMipmapLevels[0].pSurfaceData, GL_DYNAMIC_DRAW);
                 VMSVGA3D_CHECK_LAST_ERROR(pState, pContext);
@@ -6050,5 +6050,5 @@
         else
         {
-            Assert(pRange[iPrimitive].indexBias >= 0);  /* @todo */
+            Assert(pRange[iPrimitive].indexBias >= 0);  /** @todo  indexBias */
             Assert(pRange[iPrimitive].indexWidth == pRange[iPrimitive].indexArray.stride);
 