Index: trunk/src/VBox/Main/src-server/win/NetIf-win.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/win/NetIf-win.cpp	(revision 57556)
+++ trunk/src/VBox/Main/src-server/win/NetIf-win.cpp	(revision 57596)
@@ -965,5 +965,5 @@
                 LogRel(("vboxNetWinAddComponent: collectNetIfInfo() -> %Rrc\n", rc));
             }
-            LogRel(("vboxNetWinAddComponent: adding %ls\n", lpszName));
+            Log(("vboxNetWinAddComponent: adding %ls\n", lpszName));
             /* create a new object and add it to the list */
             ComObjPtr<HostNetworkInterface> iface;
@@ -1016,5 +1016,5 @@
             hr = pMpNcc->GetDisplayName(&pwszName);
             if (hr == S_OK)
-                LogRel(("netIfListHostAdapters: %ls\n", pwszName));
+                Log(("netIfListHostAdapters: %ls\n", pwszName));
             else
                 LogRel(("netIfListHostAdapters: failed to get device display name (0x%x)\n", hr));
@@ -1029,5 +1029,5 @@
                     if (hr == S_OK)
                     {
-                        LogRel(("netIfListHostAdapters: id = %ls\n", pId));
+                        Log(("netIfListHostAdapters: id = %ls\n", pId));
                         if (!_wcsnicmp(pId, L"sun_VBoxNetAdp", sizeof(L"sun_VBoxNetAdp")/2))
                         {
@@ -1470,5 +1470,5 @@
     int                  iDefault = getDefaultInterfaceIndex();
 
-    LogRel(("NetIfList: building the list of interfaces\n"));
+    Log(("NetIfList: building the list of interfaces\n"));
     /* we are using the INetCfg API for getting the list of miniports */
     hr = VBoxNetCfgWinQueryINetCfg(&pNc, FALSE,
@@ -1539,5 +1539,5 @@
                         while ((hr = pEnumBp->Next(1, &pBp, NULL)) == S_OK)
                         {
-                            LogRel(("NetIfList: fetched INetCfgBindingPath interface\n"));
+                            Log(("NetIfList: fetched INetCfgBindingPath interface\n"));
                             /* S_OK == enabled, S_FALSE == disabled */
                             if (pBp->IsEnabled() == S_OK)
@@ -1553,5 +1553,5 @@
                                         while ((hr = pEnumBi->Next(1, &pBi, NULL)) == S_OK)
                                         {
-                                            LogRel(("NetIfList: fetched INetCfgBindingInterface interface\n"));
+                                            Log(("NetIfList: fetched INetCfgBindingInterface interface\n"));
                                             hr = pBi->GetLowerComponent(&pMpNcc);
                                             Assert(hr == S_OK);
@@ -1562,5 +1562,5 @@
                                                 hr = pMpNcc->GetDisplayName(&pwszName);
                                                 if (hr == S_OK)
-                                                    LogRel(("NetIfList: got %ls\n", pwszName));
+                                                    Log(("NetIfList: got %ls\n", pwszName));
                                                 else
                                                     LogRel(("NetIfList: failed to get device display name (0x%x)\n", hr));
@@ -1575,5 +1575,5 @@
                                                         if (hr == S_OK)
                                                         {
-                                                            LogRel(("NetIfList: fetched network adapter id: %.80ls\n", pId));
+                                                            Log(("NetIfList: fetched network adapter id: %.80ls\n", pId));
                                                             /*
                                                              * Host-only interfaces are ignored here and included into the list
@@ -1672,5 +1672,5 @@
         for (pAdapter = pAddresses; pAdapter; pAdapter = pAdapter->Next)
         {
-            LogRel(("Enumerating %s\n", pAdapter->AdapterName));
+            Log(("Enumerating %s\n", pAdapter->AdapterName));
             /* Vista+ systems introduced separate type for wireless adapters */
             if (pAdapter->IfType != IF_TYPE_ETHERNET_CSMACD && pAdapter->IfType != IF_TYPE_IEEE80211)
@@ -1781,6 +1781,6 @@
                     ? HostNetworkInterfaceType_HostOnly
                     : HostNetworkInterfaceType_Bridged;
-                LogRel(("Adding %ls as %s\n", pAdapter->Description,
-                        enmType == HostNetworkInterfaceType_Bridged ? "bridged" : "host-only"));
+                Log(("Adding %ls as %s\n", pAdapter->Description,
+                     enmType == HostNetworkInterfaceType_Bridged ? "bridged" : "host-only"));
                 /* create a new object and add it to the list */
                 ComObjPtr<HostNetworkInterface> iface;
@@ -1797,5 +1797,5 @@
                 else
                 {
-                    LogRel(("vboxNetWinAddComponent: HostNetworkInterface::init() -> %Rrc\n", rc));
+                    LogRel(("NetIfList: HostNetworkInterface::init() -> %Rrc\n", rc));
                     Assert(0);
                 }